



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>GitLab搭建详细过程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">GitLab搭建详细过程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 08:24:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一、前提</h1>
<ol><li>系统：Centos 6.5</li>
<li>软件版本：gitlab-7.8.4</li>
<li>Selinux：关闭</li>
<li>防火墙规则：先清空（搭建好了后续自己添加相关放行规则）</li></ol>
<h1>二、yum源配置和相关依赖包</h1>
<h2>1.添加epel源和PUIAS_6_computational源</h2>
<div>
<pre class="prettyprint linenums"># yum -y install epel-release
</pre>
</div>
<p>创建该文件并添加以下内容：</p>
<div>
<pre class="prettyprint linenums"># vim /etc/yum.repos.d/PUIAS_6_computational.repo<br />
[PUIAS_6_computational]<br />
name=PUIAS computational Base $releasever - $basearch<br />
mirrorlist=http://puias.math.ias.edu/data/puias/computational/$releasever/$basearch/mirrorlist<br />
#baseurl=http://puias.math.ias.edu/data/puias/computational/$releasever/$basearch<br />
gpgcheck=1<br />
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-puias
</pre>
</div>
<p>　 获取和导入相关验证文件</p>
<div>
<pre class="prettyprint linenums"># wget -O /etc/pki/rpm-gpg/RPM-GPG-KEY-puias http://springdale.math.ias.edu/data/puias/6/x86_64/os/RPM-GPG-KEY-puias<br />
# rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-puias<br />
# yum repolist</pre>
</div>
<h2>2.安装依赖包</h2>
<div>
<pre class="prettyprint linenums"># yum install -y vim lrzsz wget gcc gcc-c++ make makeconf cmake<br />
# yum -y update<br />
# yum -y groupinstall 'Development Tools'<br />
# yum -y install readline readline-devel ncurses-devel gdbm-devel glibc-devel tcl-devel openssl-devel curl-devel expat-devel db4-devel byacc sqlite-devel libyaml libyaml-devel libffi libffi-devel libxml2 libxml2-devel libxslt libxslt-devel libicu libicu-devel system-config-firewall-tui redis sudo wget crontabs logwatch logrotate perl-Time-HiRes git cmake libcom_err-devel.i686 libcom_err-devel.x86_64 nodejs cmake libicu-devel libicu openssl openssl-devel

查看安装的git版本，需要1.7.12以上，有PUIAS源会装1.8<br />
# git --version</pre>
</div>
<h1>三、安装Ruby</h1>
<h2>1.查看是否安装有Ruby</h2>
<div>
<pre class="prettyprint linenums"># rpm -qa | grep ruby
</pre>
</div>
<h2>2.安装Ruby</h2>
<div>
<pre class="prettyprint linenums"># mkdir /tmp/ruby &amp;&amp; cd /tmp/ruby<br />
# curl --progress ftp://ftp.ruby-lang.org/pub/ruby/2.1/ruby-2.1.2.tar.gz | tar xz<br />
# cd ruby-2.1.2<br />
# ./configure --disable-install-rdoc<br />
# make<br />
# make prefix=/usr/local install
</pre>
</div>
<h2>3.安装Bundler Gem</h2>
<div>
<pre class="prettyprint linenums"># gem install bundler --no-doc
</pre>
</div>
<p>可能会报以下错误，这是因为国内网络导致rubygems.org存放在Amazon S3上面的资源文件间接性链接失败，用国内的RubyGems镜像(参见http://ruby.taobao.org/)替换官方镜像</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171116182732593-990424982.png" /></p>
<p>更换镜像地址：</p>
<div>
<pre class="prettyprint linenums"># gem sources --remove https://rubygems.org/		# 删除原镜像地址<br />
# gem sources -a https://ruby.taobao.org/			# 添加新镜像地址
</pre>
</div>
<p>查看是否更换成功：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171116182842859-1360038259.png" /></p>
<p>再次安装：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171116182901374-85982908.png" /></p>
<h1>四、创建系统用户git</h1>
<div>
<pre class="prettyprint linenums"># adduser --system --shell /bin/bash --comment 'GitLab' --create-home --home-dir /home/git/ git<br />
让git用户可以找到/usr/local/bin命令，并可以使用sudo<br />
# visudo<br />
找到这一行:<br />
Defaults    secure_path = /sbin:/bin:/usr/sbin:/usr/bin<br />
在后面添加 /usr/local/bin :<br />
Defaults    secure_path = /sbin:/bin:/usr/sbin:/usr/bin:/usr/local/bin<br />
再找到这一行：<br />
root    ALL=(ALL)       ALL<br />
在下一行添加：<br />
git    ALL=(ALL)       ALL
</pre>
</div>
<h1>五、安装MySQL</h1>
<h2>1.前提</h2>
<p>这里的数据库需要安装Mysql 5.5以上的版本，而epel源默认只有5.1，所以需要添加有Mysql 5.5的源</p>
<div>
<pre class="prettyprint linenums"># rpm -qa | grep mysql   # 查看是否安装比较低版本的mysql，然后卸载<br />
# yum remove -y mysql*<br />
# yum install -y mysql55-server mysql55-devel mysql55 postfix # 安装5.5版本<br />
# chkconfig mysqld on   # 设置开机启动<br />
# service mysqld start
</pre>
</div>
<p>要求是InnoDB引擎，登陆查看是否为InnoDB引擎</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171116180750624-300984572.png" /></p>
<p>如果不是可以用SET storage_engine=INNODB设置，或者修改my.cnf文件后重启mysql</p>
<h2>2.配置GitLab使用的数据库</h2>
<div>
<pre class="prettyprint linenums">&gt; CREATE DATABASE IF NOT EXISTS `gitlabhq_production` DEFAULT CHARACTER SET `utf8` COLLATE `utf8_unicode_ci`;<br />
&gt; GRANT SELECT, LOCK TABLES, INSERT, UPDATE, DELETE, CREATE, DROP, INDEX, ALTER ON `gitlabhq_production`.* TO 'git'@'localhost' identified by 'git';<br />
&gt; GRANT SELECT, LOCK TABLES, INSERT, UPDATE, DELETE, CREATE, DROP, INDEX, ALTER ON `gitlabhq_production`.* TO 'git'@'127.0.0.1' identified by 'git';<br />
&gt; flush privileges;<br />
&gt; exit;</pre>
</div>
<h2>六、安装Redis</h2>
<p>安装Reids</p>
<div>
<pre class="prettyprint linenums"># yum -y install redis<br />
# chkconfig redis on<br />
# cp /etc/redis.conf /etc/redis.conf.orig
</pre>
</div>
<p>下面这条命令会把redis.conf的端口设置为0，而redis.conf.orig不变</p>
<div>
<pre class="prettyprint linenums"># sed 's/^port .*/port 0/' /etc/redis.conf.orig | sudo tee /etc/redis.conf<br />
# echo 'unixsocket /var/run/redis/redis.sock' | sudo tee -a /etc/redis.conf<br />
# echo -e 'unixsocketperm 0770' | sudo tee -a /etc/redis.conf
</pre>
</div>
<p>授权/var/run/redis给redis权限</p>
<div>
<pre class="prettyprint linenums"># mkdir -p /var/run/redis/<br />
# chown redis:redis /var/run/redis<br />
# chmod 755 /var/run/redis
</pre>
</div>
<p>将git加入redis组，并启动Redis</p>
<div>
<pre class="prettyprint linenums"># usermod -aG redis git<br />
# service redis start</pre>
</div>
<h1>七、安装GitLab</h1>
<h2>1.克隆GitLab</h2>
<div>
<pre class="prettyprint linenums"># su - git<br />
# cd /home/git<br />
# git clone https://gitlab.com/larryli/gitlab.git -b 7-8-zh gitlab
</pre>
</div>
<h2>2.配置</h2>
<p>切换至GitLab目录下面，复制一份配置文件</p>
<div>
<pre class="prettyprint linenums"># cd gitlab<br />
# cp config/gitlab.yml.example config/gitlab.yml
</pre>
</div>
<p>确保GitLab可以对 log 和 tmp 目录有写入权限</p>
<div>
<pre class="prettyprint linenums"># chown -R git log/<br />
# chown -R git tmp/<br />
# chmod -R u+rwX log/<br />
# chmod -R u+rwX tmp/</pre>
</div>
<p>为satelites创建目录</p>
<div>
<pre class="prettyprint linenums"># mkdir /home/git/gitlab-satellites<br />
# chmod u+rwx,g=rx,o-rwx /home/git/gitlab-satellites
</pre>
</div>
<p>确保GitLab可以对 tmp/pids、tmp/sockets、public/uploads目录有写入权限</p>
<div>
<pre class="prettyprint linenums"># chmod -R u+rwX tmp/pids/<br />
# chmod -R u+rwX tmp/sockets/<br />
# chmod -R u+rwX  public/uploads
</pre>
</div>
<p>从配置案例复制一份unicorn配置文件，并修改配置文件中的timeout选项的值为600（防止仓库文件太大，拉取时间过长出现超时）</p>
<div>
<pre class="prettyprint linenums"># su -<br />
# cd /home/git/gitlab<br />
# sudo -u git -H cp config/unicorn.rb.example config/unicorn.rb<br />
# vim gitlab/config/unicorn.rb<br />
修改timeout 600
</pre>
</div>
<p>从配置案例复制一份rack attack配置文件</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H cp config/initializers/rack_attack.rb.example config/initializers/rack_attack.rb
</pre>
</div>
<p>为git用户配置git全局配置</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H git config --global user.name "GitLab"<br />
# sudo -u git -H git config --global user.email "xxxxxx@qq.com"<br />
# sudo -u git -H git config --global core.autocrlf input
</pre>
</div>
<p>配置redis连接</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H cp config/resque.yml.example config/resque.yml
</pre>
</div>
<p>配置GitLab数据库设置</p>
<div>
<pre class="prettyprint linenums"># sudo -u git cp config/database.yml.mysql config/database.yml<br />
# vim config/database.yml
</pre>
</div>
<p>只需配置生产的部分（第一部分），用户名和密码</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171117100544124-398442875.png" /></p>
<p>配置好以后运行该命令</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H chmod o-rwx config/database.yml
</pre>
</div>
<p>配置GitLab绑定的域名或者IP</p>
<div>
<pre class="prettyprint linenums"># vim config/gitlab.yml<br />
修改host为gitlab的域名为你主机的IP地址（有两项，test一项应该没有影响，不过也修改吧）<br />
host：主机IP
</pre>
</div>
<p>安装Gems</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H bundle install --deployment --without development test postgres aws
</pre>
</div>
<p>可能会报错，还是大陆访问官网的问题，替换成https://ruby.taobao.org，然后再安装</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171117101114718-1234667565.png" /></p>
<p>替换命令：</p>
<div>
<pre class="prettyprint linenums"># sed -i '/^source/s/https\:\/\/rubygems\.org/https\:\/\/ruby\.taobao\.org/' Gemfile
</pre>
</div>
<p>安装GitLab shell</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H bundle exec rake gitlab:shell:install[v2.5.4] REDIS_URL=unix:/var/run/redis/redis.sock RAILS_ENV=production
</pre>
</div>
<p>初始化数据库</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H bundle exec rake gitlab:setup RAILS_ENV=production
</pre>
</div>
<p>如果想要自己设置GitLab的root默认登陆密码则运行以下命令：</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H bundle exec rake gitlab:setup RAILS_ENV=production GITLAB_ROOT_PASSWORD=yourpassword
</pre>
</div>
<p>默认登陆账号密码</p>
<div>
<pre class="prettyprint linenums">login.........root<br />
password......5iveL!fe
</pre>
</div>
<p>配置启动脚本</p>
<div>
<pre class="prettyprint linenums"># cp lib/support/init.d/gitlab /etc/init.d/
</pre>
</div>
<p>配置日志切割</p>
<div>
<pre class="prettyprint linenums"># cp lib/support/logrotate/gitlab /etc/logrotate.d/gitlab
</pre>
</div>
<p>运行命令检测GitLab和它的环境是否正确</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H bundle exec rake gitlab:env:info RAILS_ENV=production
</pre>
</div>
<p>运行命令结果截图如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171117101603562-101060363.png" /></p>
<p>拉取GitLab静态资源文件</p>
<div>
<pre class="prettyprint linenums"># sudo -u git -H bundle exec rake assets:precompile RAILS_ENV=production
</pre>
</div>
<p>修改配置文件的gitlab_url为主机IP或者域名</p>
<div>
<pre class="prettyprint linenums"># vim /home/git/gitlab-shell/config.yml
</pre>
</div>
<p>启动GitLab实例</p>
<div>
<pre class="prettyprint linenums"># service gitlab start</pre>
</div>
<h1>八、配置Nginx</h1>
<p>安装和配置开机启动（这里用yum安装，也可以自己编译安装）</p>
<div>
<pre class="prettyprint linenums"># yum install -y nginx<br />
# chkconfig nginx on
</pre>
</div>
<p>下载Nginx配置文件，并命名为gitlab.conf</p>
<div>
<pre class="prettyprint linenums"># wget -O /etc/nginx/conf.d/gitlab.conf https://gitlab.com/gitlab-org/gitlab-ce/raw/master/lib/support/nginx/gitlab
</pre>
</div>
<p>把nginx加入到git组</p>
<div>
<pre class="prettyprint linenums"># usermod -a -G git nginx<br />
# chmod g+rx /home/git/
</pre>
</div>
<p>修改gitlab.conf文件</p>
<div>
<pre class="prettyprint linenums"># vim /etc/nginx/conf.d/gitlab.conf<br />
server unix:/home/git/gitlab/tmp/sockets/gitlab-workhorse.socket fail_timeout=0; 修改为 server unix:/home/git/gitlab/tmp/sockets/gitlab.socket fail_timeout=0;<br />
listen 0.0.0.0:80 default_server;   修改为 listen 80;<br />
listen [::]:80 default_server;       该行删除<br />
server_name YOUR_SERVER_FQDN;  修改为 server_name 主机IP
</pre>
</div>
<p>启动Nginx</p>
<div>
<pre class="prettyprint linenums"># service nginx start</pre>
</div>
<h1>九、访问</h1>
<p>访问地址，http://主机IP或者域名，第一次登陆后就需要修改root用户的密码，然后再去掉GitLab的用户注册功能。到此GitLab搭建完毕！</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/754572/201711/754572-20171117102726062-1561776734.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r6j2r9.html">iOS---类方法（静态方法）和实例方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xom68.html">&lbrack;原创&rsqb;java WEB学习笔记97：Spring学习---Spring 中的 Bean 配置&colon;IOC 和 DI</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd24lm8.html">Android-RecyclerView-Item点击事件设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5ddr8.html">JAVA实现的截屏程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zn4x09.html">Asp&period;Net 常用工具类之加密&mdash;&mdash;对称加密DES算法（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zk508.html">angular &dollar;compiler</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jg7xv8.html">&period;net通用防SQL注入漏洞程序&lpar;Global&period;asax方式&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jn1ol8.html">零基础新手学习Java必须知道的市场行情</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj6kox9.html">python第一周总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj3z2l8.html">CodeForces 510C Fox And Names &lpar;拓扑排序&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96035x39.html">方法调用 Controller的Action 参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdonvz9.html">html 网页背景图片根据屏幕大小CSS自动缩放</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv5n0g8.html">MySQL建库建表</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzzv6q.html">剑指Offer 34&period; 第一个只出现一次的字符 （字符串）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13oexq.html">c&num; &period;net 面试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvj01gq.html">jquery的html代码中a的onclick的正确显示的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e5dwx9.html">psp0级报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pejln8.html">OpenCV---像素运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/96m07vj8.html">twitter storm常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x5l1o9.html">制作Makefile中  &ast;&ast; missing separator 错误解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rgkz0d8.html">zoj 1938 Binomial Showdown 组合数裸基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z3goe9.html">阿里云AliYun表格存储&lpar;Table Store&rpar;相关案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpr1d39.html">从实践的角度理解cookie的几个属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z0m1e9.html">算法-找出与目标数字相同的digit组成的整数中比该数字大的数集中的最小数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z3zyj9.html">使用svn与maven管理的项目导入Eclipse，但是与本地svn客户端关联不上？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mer2d2q.html">Guava快速入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd2w7k9.html">声明数组变量&sol;&sol;&sol; 计算所有元素的总和&sol;打印所有元素总和&sol;输出&sol;foreach循环&sol;数组作为函数的参数&sol;调用printArray方法打印</a>
			</li>
						<li><a href="https://www.batexi.com/a/8merdd2q.html">记录一个Unity播放器插件的开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv13dpyq.html">C&num; WinForm DataGridView让DataPropertyName支持复杂属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jymel8.html">Java Swing学习</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
